//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "uGrab.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
HHOOK g_Hook;
_Grab *g_Grab;
//-------------
LRESULT CALLBACK LowLevelMouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
   HHOOK hHook = g_Hook;
   if (nCode < 0)
      return CallNextHookEx(hHook, nCode, wParam, lParam);

   MSLLHOOKSTRUCT *msHook=(MSLLHOOKSTRUCT *)lParam;
   HWND hWnd = WindowFromPoint(msHook->pt);
   switch(wParam){
   case WM_LBUTTONDOWN: g_Grab->fnFram(hWnd, msHook->pt);
   break;
   case WM_LBUTTONUP:   g_Grab->fnUnFram();
   break;
   case WM_MOUSEMOVE:   g_Grab->fnFramDrag(msHook->pt);
   break;
   }
   return CallNextHookEx(hHook, nCode, wParam, lParam);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   g_Hook = SetWindowsHookEx(WH_MOUSE_LL, (HOOKPROC)LowLevelMouseProc, GetModuleHandle(NULL), 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   g_Grab= new _Grab(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete g_Grab;
   UnhookWindowsHookEx(g_Hook);
}
//---------------------------------------------------------------------------
 